#pragma once

using namespace Gdiplus;

class CBaseControl {
public:
	HWND Handle;
	void Invalidate();
	void Move(int x, int y, int cx, int cy);
	BOOL Show();
	BOOL Hide();
	BOOL Enable();
	BOOL Disable();
};

class CWinControl : public CBaseControl {
protected:
	static LRESULT CALLBACK tWndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
	static LRESULT CALLBACK initWindowProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
	virtual LRESULT WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
};

//
// CPanel
// DrawPath()  Override ĎgPȂpl
//
class CPPanel : public CWinControl {
private:
	BOOL m_bMouseOver;
	BOOL m_bEnable;
	LRESULT WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
	void PaintImage(HWND hWnd);
protected:
	HWND m_hWndOwner;
	BOOL m_bLButtonDown;
	virtual int DrawPath(Graphics *g, Pen *pen, LinearGradientBrush *brush, SolidBrush *brush2, RECT *rc);
public:
	CPPanel();
	HWND CreatePanel(HWND hWnd, HINSTANCE hInst, int id);
	void SetEnable(BOOL bEnable);
	virtual void OnLButtonUp(){};
	virtual void OnLButtonDown(){};
	virtual void OnMouseMove(){};
	virtual void OnSize(){};
};

//
// CGButton
// Glyph OgĎ؂ւ{^
//
class CGButton : public CWinControl {
private:
	BOOL m_MouseOver;
	BOOL m_LButtonDown;
	Image *HotImg;
	Image *ColdImg;
	Image *PushImg;
	int m_Width;
	int m_Height;
	int m_ButtonID;
	HWND m_hWndOwner;
	void PaintImage(HWND hWnd);
	BOOL DeleteGlyph();
	LRESULT WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
public:
	HWND CreateButton(HWND hWnd, HINSTANCE hInst, RECT rc, int id, int id_Cold, int id_Hot, int id_Push);
	void SetGlyph(HINSTANCE hInst, int id_Cold, int id_Hot, int id_Push);
	CGButton();
	~CGButton();
};

//
// CPButton
// ߗOiK؂ւ{^
// DrawPath()  Override Ďg
//
class CPButton : public CWinControl {
private:
	BOOL m_MouseOver;
	BOOL m_LButtonDown;
	Image *HotImg;
	Image *ColdImg;
	Image *PushImg;
	int m_Width;
	int m_Height;
	int m_ButtonID;
	HWND m_hWndOwner;
	BOOL m_bDown;
	void PaintImage(HWND hWnd);
	LRESULT WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
protected:
	virtual int DrawPath(Graphics *g, Pen *pen, LinearGradientBrush *brush, Rect rc);
public:
	void Down(BOOL down);
	BOOL isDown();
	HWND CreateButton(HWND hWnd, HINSTANCE hInst, RECT rc, int id);
};

//
// CGrip
// ʒuObv̊{NX
// OnMove  Override ĐeECh̃TCY
//
class CGrip : public CWinControl {
private:
	BOOL m_MouseOver;
	BOOL m_LButtonDown;
	POINT m_DownPoint;
	INT m_DownX;
	//WORD m_DownX;
	HWND m_hWndOwner;
	int m_MoveSize;
	void PaintImage(HWND hWnd);
	LRESULT WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
protected:
	virtual int OnMove(int nPlus){return 0;};
	virtual int DrawPath(Graphics *g, Pen *pen, RECT rc){return 0;};
public:
	HWND CreateGrip(HWND hWnd, HINSTANCE hInst, RECT rc, int id);
};

#define	WM_BUTTONNOTIFY (WM_APP + 2)