#include "StdAfx.h"
#include "DirectA.h"
#include "y901w.h"
#include "Tool.h"
#include "fname.h"

CDirectA *DirectA;

CDirectA::CDirectA(HWND hParent, HINSTANCE hInst, int id)
{
	/*m_CursorHide = FALSE;
	m_StartTime = 0;
	m_MusicFile = TRUE;
	m_EndTime = 0;*/
	pGraphBuilder = NULL;
	pMediaControl = NULL;
	pMediaEventEx = NULL;
	pMediaSeeking = NULL;
	pBasicAudio = NULL;
	//
	pCaptureGraphBuilder2 = NULL;
	pVMRWindowlessControl = NULL;
	pVMRFilterConfig = NULL;
	pWMAsfReader = NULL;
	pASFReader = NULL;
	pVmr9 = NULL;
	pSource = NULL;
	//PlayState = dsStop;
	SetRect(&rcVideo, 0, 0, 320, 1);
	//WNDCLASS
	WNDCLASSEX wcex;
	wcex.cbSize = sizeof(WNDCLASSEX);
	wcex.style			= CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS;
	wcex.lpfnWndProc	= initWindowProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInst;
	wcex.hIcon			= NULL;
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= NULL;
	wcex.lpszMenuName	= NULL;
	wcex.lpszClassName	= L"DS_Window";
	wcex.hIconSm		= NULL;
	RegisterClassEx(&wcex);
	//ECh쐬
	Handle = CreateWindow(
		L"DS_Window",
		NULL,
		WS_CHILD | WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_VISIBLE,
		0,0,1,1,
		hParent,
		(HMENU)IntToPtr(id),
		hInst,
		this);
	// Direct3D̏
	pD3D = Direct3DCreate9( D3D_SDK_VERSION );
	//if (g_pD3D == NULL) return 0;
	ZeroMemory(&D3DPP, sizeof(D3DPP));
	D3DPP.Windowed = TRUE;
	D3DPP.SwapEffect = D3DSWAPEFFECT_DISCARD;
	D3DPP.BackBufferFormat = D3DFMT_UNKNOWN;
	pD3D->CreateDevice( D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, Handle, D3DCREATE_SOFTWARE_VERTEXPROCESSING, &D3DPP, &pD3DDevice );
	CoInitializeEx(NULL, COINIT_APARTMENTTHREADED);
}

CDirectA::~CDirectA(void)
{
	ReleaceAll();
	CoUninitialize();
	pD3DDevice->Release();
	pD3D->Release();
}

void CDirectA::ReleaceAll()
{
	if (pMediaEventEx)
	{
		pMediaEventEx->SetNotifyFlags(AM_MEDIAEVENT_NONOTIFY);
		pMediaEventEx->SetNotifyWindow(NULL, WM_GRAPHNOTIFY, (LONG_PTR)pMediaEventEx);
		pMediaEventEx->Release();
		pMediaEventEx = NULL;
	}
	if (pMediaSeeking)
	{
		pMediaSeeking->Release();
		pMediaSeeking = NULL;
	}
	if (pMediaControl)
	{
		pMediaControl->Stop();
		pMediaControl->Release();
		pMediaControl = NULL;
	}
	if (pCaptureGraphBuilder2)
	{
		pCaptureGraphBuilder2->Release();
		pCaptureGraphBuilder2 = NULL;
	}
	if (pVMRWindowlessControl)
	{
		RECT rc = {0,0,0,0};
		pVMRWindowlessControl->SetVideoPosition(&rc, &rc);
		pVMRWindowlessControl->SetVideoClippingWindow(NULL);
		pVMRWindowlessControl->Release();
		pVMRWindowlessControl = NULL;
	}
	if (pVMRFilterConfig)
	{
		pVMRFilterConfig->Release();
		pVMRFilterConfig = NULL;
	}
	if (pBasicAudio)
	{
		pBasicAudio->Release();
		pBasicAudio = NULL;
	}
	if (pASFReader)
	{
		pASFReader->Release();
		pASFReader = NULL;
	}
	if (pWMAsfReader)
	{
		pWMAsfReader->Release();
		pWMAsfReader = NULL;
	}
	if (pSource)
	{
		pSource->Release();
		pSource = NULL;
	}
	if (pVmr9)
	{
		pVmr9->Release();
		pVmr9 = NULL;
	}
	if (pGraphBuilder)
	{
		pGraphBuilder->Release();
		pGraphBuilder = NULL;
	}
}

void CDirectA::SetURL(HWND hWnd, LPWSTR url)
{
	//V[gJbg`FbN
	wchar_t szExt[1024];
	fname::get_FileExt(url, szExt);
	if (_wcsicmp(szExt, L".lnk")==0)
	{
		fname::get_FileLink(url, m_PlayFile);
		fname::get_FileExt(m_PlayFile, szExt);
	} else {
		wcscpy_s(m_PlayFile, 1024, url);
	}
	//Jn
	ReleaceAll();
	m_StartTime = 0;
	m_MusicFile = TRUE;
	HRESULT hr;
	hr = ::CoCreateInstance(CLSID_FilterGraph, NULL, CLSCTX_INPROC_SERVER, IID_IGraphBuilder, (LPVOID *)&pGraphBuilder);
	if (FAILED(hr)) {
		ReleaceAll();
		DoMessage(hWnd, L"Errer IGraphBuilder Create");
		return;
	}
	hr = pGraphBuilder->QueryInterface(IID_IBasicAudio, (LPVOID *)&pBasicAudio);
	if (FAILED(hr)) {
		ReleaceAll();
		DoMessage(hWnd, L"Errer IBasicAudio Create");
		return;
	}
	//VMR9 Filter Create
	hr = CoCreateInstance( CLSID_VideoMixingRenderer9, NULL, CLSCTX_INPROC_SERVER, IID_IBaseFilter, (LPVOID *)&pVmr9);
	if (FAILED(hr)) {
		ReleaceAll();
		DoMessage(hWnd, L"Errer VideoMixingRenderer9 Create");
		return;
	}
	hr = pGraphBuilder->AddFilter(pVmr9, L"VMR9");
	if (FAILED(hr)) {
		ReleaceAll();
		DoMessage(hWnd, L"Errer VMR9 Add Filter");
		return;
	}
	//Windowless ɂĕ`ʃEChw
	hr = pVmr9->QueryInterface(IID_IVMRFilterConfig9, (LPVOID *)&pVMRFilterConfig);
	if (FAILED(hr)) {
		ReleaceAll();
		DoMessage(hWnd, L"Errer IVMRFilterConfig9 Create");
		return;
	}
	hr = pVMRFilterConfig->SetRenderingMode(VMRMode_Windowless); //VMRMode_Windowed
	if (FAILED(hr)) {
		ReleaceAll();
		DoMessage(hWnd, L"Errer SetRenderingMode Change");
		return;
	}
	hr = pVmr9->QueryInterface(IID_IVMRWindowlessControl9, (LPVOID *)&pVMRWindowlessControl);
	if (FAILED(hr)) {
		ReleaceAll();
		DoMessage(hWnd, L"Errer IVMRWindowlessControl9 Create");
		return;
	}
	hr = pVMRWindowlessControl->SetVideoClippingWindow(Handle);
	if (FAILED(hr)) {
		ReleaceAll();
		DoMessage(hWnd, L"Errer SetVideoClippingWindow Owner");
		return;
	}
	//\[XtB^̍쐬Ao^
	hr = pGraphBuilder->AddSourceFilter(m_PlayFile, L"SFLT", &pSource);
	if (FAILED(hr)) {
		ReleaceAll();
		DoMessage(hWnd, L"Errer AddSourceFilter");
		return;
	}
	//ICaptureGraphBuilder2 C^[tFCX擾
	hr = CoCreateInstance(CLSID_CaptureGraphBuilder2, NULL, CLSCTX_INPROC_SERVER, IID_ICaptureGraphBuilder2,
		(LPVOID *)&pCaptureGraphBuilder2);
	if (FAILED(hr)) {
		ReleaceAll();
		DoMessage(hWnd, L"Errer ICaptureGraphBuilder2 Create");
		return;
	}
	hr = pCaptureGraphBuilder2->SetFiltergraph(pGraphBuilder);
	if (FAILED(hr)) {
		ReleaceAll();
		DoMessage(hWnd, L"Errer SetFilterGraph");
		return;
	}
	//łăRł炵AAzNT
	hr = pGraphBuilder->RenderFile(m_PlayFile, NULL);
	if (FAILED(hr)) {
		ReleaceAll();
		DoMessage(hWnd, L"Errer RenderFile");
		return;
	}
	// VMR9 end

	//TCY֘A
	BOOL bFlash = FALSE;
	rcVideo.top = 0;
	rcVideo.left = 0;
	LONG na,nb;
	pVMRWindowlessControl->GetNativeVideoSize(&rcVideo.right, &rcVideo.bottom, &na, &nb);
	if (rcVideo.right <= 0) {
		::SetRect(&rcVideo, 0, 0, 0, 0);
		Invalidate();	//OiĉŁc
	} else {
		m_MusicFile = FALSE;
		RECT rcClient;
		//AXyNg
		if (1)//(CinemaWindow->BtnSetting.nAspect == 0)
		{
			hr = pVMRWindowlessControl->SetAspectRatioMode(VMR9ARMode_LetterBox);
			if (FAILED(hr)) {
				ReleaceAll();
				DoMessage(hWnd, L"Errer SetAspectRatioMode");
				return;
			}
			::GetClientRect(y901w->hWnd, &rcClient);
			CalcVideoRect(&rcClient, &rcVideo);
			Move(0, 0, rcClient.right, rcClient.bottom);
			pVMRWindowlessControl->SetVideoPosition(&rcVideo, &rcClient);
		} else {
			/*hr = pVMRWindowlessControl->SetAspectRatioMode(VMR9ARMode_None);
			if (FAILED(hr)) {
				ReleaceAll();
				DoMessage(hWnd, L"Errer SetAspectRatioMode");
				return;
			}
			rcVisible = rcVideo;
			switch (CinemaWindow->BtnSetting.nAspect)
			{
			case 1:
				rcVisible.right = rcVideo.bottom * 4 / 3;
				break;
			case 2:
				rcVisible.right = rcVideo.bottom * 16 / 9;
				break;
			case 3:
				rcVisible.right = rcVideo.bottom * CinemaWindow->IniSetting.nAspW / CinemaWindow->IniSetting.nAspH;
				break;
			}
			CinemaWindow->CalcClientRect(&rcVisible, &rcClient);
			CalcVideoRect(&rcClient, &rcVisible);
			Move(0, 0, rcClient.right, rcClient.bottom);
			pVMRWindowlessControl->SetVideoPosition(&rcVideo, &rcVisible);*/
		}
		//swprintf_s(TimePanel->szXY, 15, L" (%dx%d)", rcClient.right, rcClient.bottom);
		//TimePanel->Invalidate();
		if (!EqualRect(&m_rcClient, &rcClient)) {
			bFlash = TRUE;
		}
	}
	//Ԋ֘A
	hr = pGraphBuilder->QueryInterface(IID_IMediaSeeking, (LPVOID *)&pMediaSeeking);
	if (FAILED(hr)) {
		ReleaceAll();
		DoMessage(hWnd, L"Errer IMediaSeeking Create");
		return;
	}
	hr = pGraphBuilder->QueryInterface(IID_IMediaEventEx, (LPVOID *)&pMediaEventEx);
	if (FAILED(hr)) {
		ReleaceAll();
		DoMessage(hWnd, L"Errer IMediaEventEx Create");
		return;
	}
	pMediaEventEx->SetNotifyWindow((OAHWND)hWnd, WM_GRAPHNOTIFY, NULL);
	pMediaSeeking->GetDuration(&m_EndTime);
	m_SeekTime.SetTime(m_EndTime);
	//Play
	pMediaSeeking->SetPositions(
		&m_StartTime,
		AM_SEEKING_AbsolutePositioning,
		&m_EndTime,
		AM_SEEKING_NoPositioning);
	hr = pGraphBuilder->QueryInterface(IID_IMediaControl, (LPVOID *)&pMediaControl);
	if (FAILED(hr)) {
		ReleaceAll();
		DoMessage(hWnd, L"Errer IMediaControl Create");
		return;
	}
	//SetVolume(VolumePanel->GetVolume());
	pMediaControl->Run();
	//PlayState = dsPlay;
	//TimerOn();
	//if (bFlash)
	//	CinemaWindow->SetWindowSize();
	//PostMessage(C901->hWnd, WM_OPENSTATECHANGE, 0L, 0L);
}

BOOL CDirectA::CalcVideoRect(LPRECT prcClient, LPRECT prcVideo)
{
	int x, y;
	int left = 0;
	int top  = 0;
	if (prcClient->right * prcVideo->bottom > prcClient->bottom * prcVideo->right)
	{
		x = prcVideo->right * prcClient->bottom / prcVideo->bottom;
		y = prcClient->bottom;
		left = (prcClient->right - x) / 2;
		x += left; //WindowRECT Ȃ̂ŃRKv
	} else {
		x = prcClient->right;
		y = prcVideo->bottom * prcClient->right / prcVideo->right;
		top = (prcClient->bottom - y) /2;
		y += top;
	}
	SetRect(prcVideo, left, top, x, y);
	return TRUE;
}

BOOL CDirectA::SetVideoSize(RECT rcClient)
{
	m_rcClient = rcClient;
	if (pSource == NULL) return FALSE;
	if (m_MusicFile)
	{
		m_rcClient = rcClient;
		Move(0, 0, rcClient.right, rcClient.bottom);
		this->Invalidate();
		//swprintf_s(TimePanel->szXY, 15, L" (%dx%d)", rcClient.right, rcClient.bottom);
		//TimePanel->Invalidate();
		return FALSE;
	} else {
		DWORD dwRes;
		rcVisible = rcVideo;
		if (1)//(CinemaWindow->BtnSetting.nAspect == 0)
		{
			pVMRWindowlessControl->GetAspectRatioMode(&dwRes);
			if (dwRes == VMR9ARMode_None)
				pVMRWindowlessControl->SetAspectRatioMode(VMR9ARMode_LetterBox);
			//Move(0, 0, rcClient.right, rcClient.bottom);
			pVMRWindowlessControl->SetVideoPosition(&rcVideo, &rcClient);
			CalcVideoRect(&rcClient, &rcVisible);
		} else {
			/*pVMRWindowlessControl->GetAspectRatioMode(&dwRes);
			if (dwRes == VMR9ARMode_LetterBox)
				pVMRWindowlessControl->SetAspectRatioMode(VMR9ARMode_None);
			switch (CinemaWindow->BtnSetting.nAspect)
			{
			case 1:
				rcVisible.right = rcVideo.bottom * 4 / 3;
				break;
			case 2:
				rcVisible.right = rcVideo.bottom * 16 / 9;
				break;
			case 3:
				rcVisible.right = rcVideo.bottom * CinemaWindow->IniSetting.nAspW / CinemaWindow->IniSetting.nAspH;
				break;
			}
			CalcVideoRect(&rcClient, &rcVisible);
			//Move(0, 0, rcClient.right, rcClient.bottom);
			pVMRWindowlessControl->SetVideoPosition(&rcVideo, &rcVisible);*/
		}
		//swprintf_s(TimePanel->szXY, 15, L" (%dx%d)", rcVisible.right - rcVisible.left, rcVisible.bottom - rcVisible.top);
		//TimePanel->Invalidate();
		Move(0, 0, rcClient.right, rcClient.bottom);
		Invalidate();
	}
	return TRUE;
}
