#pragma once

#include "Controls.h"

#define dsPlay  0
#define dsPause 1
#define dsStop  2
#define dsComplete 3
#define	WM_GRAPHNOTIFY (WM_APP + 1)

struct TSeekTime {
	LONGLONG nTotal;
	LONGLONG nMin;
	LONGLONG nSec;
	BOOL SetTime(LONGLONG nTime) {
		nTotal = nTime / 10000000;
		nMin   = nTotal/60%60;
		nSec   = nTotal%60;
		return TRUE;
	}
};

class CDirectA : public CWinControl
{
private:
	RECT rcVisible;
	int m_nVolume;
	RECT rcVideo;
	LONGLONG m_StartTime;
	LONGLONG m_EndTime;
	RECT m_rcClient;
	LPDIRECT3D9 pD3D;
	D3DPRESENT_PARAMETERS D3DPP;
	LPDIRECT3DDEVICE9 pD3DDevice;
	IGraphBuilder *pGraphBuilder;
	IMediaControl *pMediaControl;
	IMediaEventEx *pMediaEventEx;
	IBasicAudio   *pBasicAudio;
	IMediaSeeking *pMediaSeeking;
	// VMR9 BEGIN
	IBaseFilter *pVmr9;
	IBaseFilter *pSource;
	IVMRFilterConfig9 *pVMRFilterConfig;
	IVMRWindowlessControl9 *pVMRWindowlessControl;
	ICaptureGraphBuilder2 *pCaptureGraphBuilder2;
	// VMR9 END and ASF BEGIN
	//IWMAsfReader *pWMAsfReader;
	IWMReader *pWMAsfReader;
	IBaseFilter *pASFReader;
	//for VMR9 END
	wchar_t m_PlayFile[1024];
	TSeekTime m_SeekTime;
	BOOL m_CursorHide;
	void OnPaint();
public:
	BOOL m_MusicFile;
	CDirectA(HWND hParent, HINSTANCE hInst, int id);
	~CDirectA(void);
	void ReleaceAll();
	void SetURL(HWND hWnd, LPWSTR url);
	BOOL CalcVideoRect(LPRECT prcClient, LPRECT prcVideo);
	BOOL SetVideoSize(RECT rcClient);
};

extern CDirectA *DirectA;
