#include "StdAfx.h"
#include "fname.h"

namespace fname
{

	struct TPath {
		TCHAR szDrive[_MAX_DRIVE];
		TCHAR szDirectory[_MAX_DIR];
		TCHAR szFname[_MAX_FNAME];
		TCHAR szExtension[_MAX_EXT];
	};

	int get_FileName(LPCTSTR lpszFileName, LPTSTR lpszResult)
	{
		TPath t;
		_tsplitpath_s(lpszFileName, t.szDrive, t.szDirectory, t.szFname, t.szExtension);
		_tcscpy_s(lpszResult, 1024, t.szFname);
		_tcscat_s(lpszResult, 1024, t.szExtension);
		return 0;
	}

	int get_FileNameOnly(LPCTSTR lpszFileName, LPTSTR lpszResult)
	{
		TPath t;
		_tsplitpath_s(lpszFileName, t.szDrive, t.szDirectory, t.szFname, t.szExtension);
		_tcscpy_s(lpszResult, 1024, t.szFname);
		return 0;
	}

	int get_FileExt(LPCTSTR lpszFileName, LPTSTR lpszResult)
	{
		TPath t;
		_tsplitpath_s(lpszFileName, t.szDrive, t.szDirectory, t.szFname, t.szExtension);
		_tcscpy_s(lpszResult, 1024, t.szExtension);
		return 0;
	}

	int get_FileDirectory(LPCTSTR lpszFileName, LPTSTR lpszResult)
	{
		TPath t;
		_tsplitpath_s(lpszFileName, t.szDrive, t.szDirectory, t.szFname, t.szExtension);
		_tcscpy_s(lpszResult, 1024, t.szDrive);
		_tcscat_s(lpszResult, 1024, t.szDirectory);
		return 0;
	}

	int get_FileLink(LPCTSTR lpszFileName, LPTSTR lpszResult)
	{
		IShellLink *pShellLink;
		IPersistFile *pPersistFile;
		WIN32_FIND_DATA fd;

		CoInitialize(NULL);
		//IShellLinkC^[tFCX̍쐬
		if (CoCreateInstance(CLSID_ShellLink, NULL, CLSCTX_INPROC_SERVER,
			IID_IShellLink, (void**)&pShellLink) == S_OK)
		{
			//IPersistFileC^[tFCX̎擾
			if (pShellLink->QueryInterface(IID_IPersistFile, (void**)&pPersistFile) == S_OK)
			{
#ifdef  _UNICODE
				pPersistFile->Load(lpszFileName, 0);
#else
				WCHAR wt[1024];
				//_tcscpy_s(wt, 1024, lpszFileName);
				MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED, lpszFileName, -1, wt, MAX_PATH );
				pPersistFile->Load((LPOLESTR)wt, 0);
#endif
				pShellLink->GetPath(lpszResult, MAX_PATH, &fd, SLGP_RAWPATH);
				pPersistFile->Release();
			}
			pShellLink->Release();
		}
		CoUninitialize();
		return 0;
	}

	int FileExists(LPCTSTR lpszFileName)
	{
		WIN32_FIND_DATA fd;
		int result = TRUE;
		HANDLE hFind = ::FindFirstFile(lpszFileName, &fd);
		if(hFind == INVALID_HANDLE_VALUE) //s
			result = FALSE;
		::FindClose(hFind);
		return result;
	}

	int DirectryExists(LPCTSTR lpszFileName)
	{
		DWORD attr = ::GetFileAttributes(lpszFileName);
		if (attr==-1)
			return FALSE;
		if ( (attr & FILE_ATTRIBUTE_DIRECTORY) != 0 )
			return TRUE;
		return FALSE;
	}
}